#include <ddraw.h>
#include <dsound.h>

#ifndef __DIRECTX_H
#define __DIRECTX_H

#ifdef __cpluplus
extern "C" {
#endif

#define ResX 192
#define ResY 160 //128

/* DirectDraw Stuff */
extern LPDIRECTDRAW7        lpDD;
extern LPDIRECTDRAWSURFACE7 lpDDS_Prim;
extern LPDIRECTDRAWSURFACE7 lpDDS_Back;
extern LPDIRECTDRAWCLIPPER  lpDDC_Clip;
extern RECT                 ScreenRect;
extern unsigned long        FGColor;
extern unsigned long        BGColor;

int  DirectDraw_Init(HWND hWnd);
void DirectDraw_Exit();
void DirectDraw_Paint(HWND hWnd);
void DirectDraw_ReSize(HWND hWnd);
void DirectDraw_ClearBackSurface();

/* DirectSound Stuff */
extern LPDIRECTSOUND8          lpDirectSound;
extern LPDIRECTSOUNDBUFFER8    lpSoundBuffer8;
extern LPDIRECTSOUNDBUFFER     lpSoundBuffer;

extern int SoundEnabled;
extern int SoundRate;
extern int SoundStereo;
extern int SoundSegs;
extern int SoundSize;
extern int WritePtr;
extern int ReadPtr;
extern int BytesPerUnit;

int  DirectSound_Init(HWND hWnd);
void DirectSound_Exit();
int  DirectSound_Silence();
int  DirectSound_Write();
int  DirectSound_GetCurrentSeg();

#ifdef __cpluplus
extern };
#endif

#endif /* __DIRECTX_H */
