/**********************************************/
/* FileLoader.cpp                             */
/*--------------------------------------------*/
/* General File I/O (Loading/Saving)          */
/*--------------------------------------------*/
/* Copyright (C) 2002 Michel Gerritse         */
/*                                            */
/* Last update: 25-09-2002                    */
/*--------------------------------------------*/
/* TODO:                                      */
/**********************************************/
#include <windows.h>
#include "DreamVMU.h"
#include "VMUCore.h"

char VmsPath[MAX_PATH];
char VmsName[MAX_PATH];
char BiosPath[MAX_PATH];
char BiosName[MAX_PATH];

/* -- Get VMS File Name */
int GetVmsName()
{
  OPENFILENAME	Open;
  char Name[2048];
  
  char  FileFilter[]=
    "Visual Memory Files (*.vms)\0"
    "*.vms\0";
    
  memset(Name, 0, sizeof(Name));
  memset(&Open, 0, sizeof(OPENFILENAME));

  /* Fill in structure */
  Open.lStructSize     = sizeof(OPENFILENAME);
  Open.hwndOwner       = DreamHWnd;
  Open.hInstance       = hInstance;
  Open.lpstrFilter     = FileFilter;
  Open.lpstrFile       = Name;
  Open.nMaxFile        = 2047;
  Open.lpstrInitialDir = VmsPath;
  Open.lpstrTitle      = "Load Visual Memory File...";
  Open.Flags           = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
  
  /* Show OPEN Dialog */
  if (GetOpenFileName(&Open) == NULL) return 1;

  strcpy(VmsName, Name);

  /* Get Path from FileName */
  int i = strlen(Name);
  for (; i >= 0; i--) if (Name[i] == '\\') break;
  if (i >= 2047) i = 2047;
  strncpy(VmsPath, Name, i);
  VmsPath[i] = '\0';
  strcat(VmsPath, "\\");

  /* Let the POTATO core load file into memory */
  if (POTATO_LoadVms(Name))
  {
    ShowMessage("Error: %s couldn't be loaded",Name);
    return 1;
  }

  return 0;
}

/* -- Get BIOS File Name */
int GetBiosName()
{
  OPENFILENAME	Open;
  char Name[2048];
  
  char  FileFilter[]=
    "Visual Memory Bios File (*.vms)\0"
    "*.vms\0";
    
  memset(Name, 0, sizeof(Name));
  memset(&Open, 0, sizeof(OPENFILENAME));

  /* Fill in structure */
  Open.lStructSize     = sizeof(OPENFILENAME);
  Open.hwndOwner       = DreamHWnd;
  Open.hInstance       = hInstance;
  Open.lpstrFilter     = FileFilter;
  Open.lpstrFile       = Name;
  Open.nMaxFile        = 2047;
  Open.lpstrInitialDir = BiosPath;
  Open.lpstrTitle      = "Load Visual Memory Bios...";
  Open.Flags           = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
  
  /* Show OPEN Dialog */
  if (GetOpenFileName(&Open) == NULL) return 1;

  strcpy(BiosName, Name);
  
  /* Get Path from FileName */
  int i = strlen(Name);
  for (; i >= 0; i--) if (Name[i] == '\\') break;
  if (i >= 2047) i = 2047;
  strncpy(BiosPath, Name, i);
  BiosPath[i] = '\0';
  strcat(BiosPath, "\\");

  /* Let the POTATO core load file into memory */
  if (POTATO_LoadBios(Name))
  {
    ShowMessage("Error: %s couldn't be loaded",Name);
    return 1;
  }

  return 0;
}