/**********************************************/
/* LCD_Render.cpp                             */
/*--------------------------------------------*/
/* POTATO LCD Screen Renderer                 */
/*--------------------------------------------*/
/* Copyright (C) 2002 Michel Gerritse         */
/*                                            */
/* Last update: 08-10-2002                    */
/*--------------------------------------------*/
/* TODO:                                      */
/**********************************************/
#include "VMUCore.h"
#include "DirectX.h"

unsigned char Icon[4][8] = 
{
  { 0x00, 0x1F, 0x23, 0x45, 0xF9, 0x21, 0x21, 0x3F },
  { 0x00, 0xFE, 0x83, 0x93, 0xBB, 0x93, 0xBB, 0xFF },
  { 0x00, 0x7C, 0x82, 0x92, 0x9A, 0x82, 0x82, 0x7C },
  { 0x00, 0x38, 0x44, 0x92, 0x92, 0x82, 0x54, 0x38 }
};

void DrawPixel(int X, int Y, int Data);

void POTATO_DrawLCD()
{
  int x, y, i;
  unsigned char Data;
  int Addr = 0;
  int Bank = 0;

  //if ((Cpu.VCCR & 0x80) == 0) /* LCD Display Off */
  //{
  //  /* Clear entire surface */
  //  DirectDraw_ClearBackSurface();
  //  return;
 // }

  //if ((Cpu.MCR & 0x8) == 0) /* LCD Refresh Off */
  //  return;

  /* Clear entire surface */
  DirectDraw_ClearBackSurface();
  
  for (y = 0; y < 32; y++) 
  {
    for (x = 0; x < 48; ) 
    {
      Data = XRam[Bank][Addr++];
 
      DrawPixel(x++, y, Data >> 7);
      DrawPixel(x++, y, Data >> 6);
      DrawPixel(x++, y, Data >> 5);
      DrawPixel(x++, y, Data >> 4);
      DrawPixel(x++, y, Data >> 3);
      DrawPixel(x++, y, Data >> 2);
      DrawPixel(x++, y, Data >> 1);
      DrawPixel(x++, y, Data     );
      
      if ((Addr & 0xF) >= 0xC) Addr += 0x4;
      
      if (Addr >= 0x80) 
      {
	      /* Switch to next XRAM bank */
        Bank++;
	      Addr -= 0x80;
      }
    }
  }
  
  if (XRam[2][0x1] & 0x40)
  {
    for (i = 0, y = 32; i < 8; i++, y++)
    {
      x = 0;
   
      Data = Icon[0][i];

      DrawPixel(x++, y, Data >> 7);
      DrawPixel(x++, y, Data >> 6);
      DrawPixel(x++, y, Data >> 5);
      DrawPixel(x++, y, Data >> 4);
      DrawPixel(x++, y, Data >> 3);
      DrawPixel(x++, y, Data >> 2);
      DrawPixel(x++, y, Data >> 1);
      DrawPixel(x++, y, Data     );
    }
  }

  if (XRam[2][0x2] & 0x10)
  {
    for (i = 0, y = 32; i < 8; i++, y++)
    {
      x = 13;
    
      Data = Icon[1][i];

      DrawPixel(x++, y, Data >> 7);
      DrawPixel(x++, y, Data >> 6);
      DrawPixel(x++, y, Data >> 5);
      DrawPixel(x++, y, Data >> 4);
      DrawPixel(x++, y, Data >> 3);
      DrawPixel(x++, y, Data >> 2);
      DrawPixel(x++, y, Data >> 1);
      DrawPixel(x++, y, Data     );
    }
  }

  if (XRam[2][0x3] & 0x4)
  {
    for (i = 0, y = 32; i < 8; i++, y++)
    {
      x = 27;
    
      Data = Icon[2][i];

      DrawPixel(x++, y, Data >> 7);
      DrawPixel(x++, y, Data >> 6);
      DrawPixel(x++, y, Data >> 5);
      DrawPixel(x++, y, Data >> 4);
      DrawPixel(x++, y, Data >> 3);
      DrawPixel(x++, y, Data >> 2);
      DrawPixel(x++, y, Data >> 1);
      DrawPixel(x++, y, Data     );
    }
  }

  if (XRam[2][0x4] & 0x1)
  {
    for (i = 0, y = 32; i < 8; i++, y++)
    {
      x = 40;
        
      Data = Icon[3][i];

      DrawPixel(x++, y, Data >> 7);
      DrawPixel(x++, y, Data >> 6);
      DrawPixel(x++, y, Data >> 5);
      DrawPixel(x++, y, Data >> 4);
      DrawPixel(x++, y, Data >> 3);
      DrawPixel(x++, y, Data >> 2);
      DrawPixel(x++, y, Data >> 1);
      DrawPixel(x++, y, Data     );
    }
  }
}

void DrawPixel(int X, int Y, int Data)
{
	DDBLTFX ddbltfx;
  RECT PixelRect;
  
  if (Data & 1)
  {
    PixelRect.left   = X << 2;
    PixelRect.top    = Y << 2;
    PixelRect.right  = PixelRect.left + 4;
    PixelRect.bottom = PixelRect.top  + 4;

    /* Draw pixel to surface */
    memset(&ddbltfx, 0, sizeof(ddbltfx));
	  
    ddbltfx.dwSize      = sizeof(ddbltfx);
    ddbltfx.dwFillColor = FGColor;
	  
    lpDDS_Back->Blt(&PixelRect, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
  }
}